/******************************************************************************/
/*	aisa31s.c																  */
/*																			  */
/*	aISA-P31															  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	Date 1998/03/05															  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/


#define	STRICT
#include	<windows.h>
#include	<tchar.h>

#include "aisa31w.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR szP31[] = _T("aISA-P31");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[256];
	DWORD dwDLLVer, dwDrvVer;
	BOOL  bResult;					// 
	WORD  wLogSlot;					// foCXi[
	BYTE  InValue, OutValue;
	AISA31RESOURCE ri;				// \[X

/*---------------------------------------------------------------------------*/
	// aisa31.dll ̎gp錾
	if (Aisa31wDllOpen() == FALSE)
	{
		ErrorMessage(AISA31_SLOT_AUTO);
		return 1;			// aisa31.dll ̃[hɎs܂
	}

/*---------------------------------------------------------------------------*/
	// o[Wԍ\
	// aISA-P31 DLL,Driver̃o[Wԍ擾
	if (Aisa31wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE)
	{
		ErrorMessage(AISA31_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("GetVersion\n")
					_T("DLL Version: %08lxh\n")
					_T("Drv Version: %08lxh"),
					dwDLLVer,
					dwDrvVer);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aISA-P31̎gp錾
	wLogSlot = AISA31_SLOT_AUTO;		// gp̃foCXT܂B
	bResult = Aisa31wCreate(&wLogSlot);	// ꍇA̎̃foCXi[܂B

	if (bResult == FALSE)		// foCX܂B
	{
		ErrorMessage(AISA31_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("aISA-P31 Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// \[X擾
	if (Aisa31wGetResource(wLogSlot, &ri) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("Board Name: %s\n")
					_T("NumPorts: %2d\n")
					_T("IO Address: %04xh-%04xh\n"),
					szP31,
					ri.dwIOPortLength[0],
					ri.dwIOPortBase[0], ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// Port 1 ɔCӂ̃f[^o
	// o̓f[^ AAh
	OutValue = (BYTE)0xAA;

	if (Aisa31wOutPort(wLogSlot, AISA31_PORT_1, OutValue) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("Port 1 փf[^o\n")
					_T("Port 1 Out Data: %02xh"),
					 OutValue);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// Port 1 f[^ǂݍ
	InValue = (BYTE)0x00;

	if (Aisa31wInPort(wLogSlot, AISA31_PORT_1, &InValue) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("Port 1 f[^\n")
					_T("Port 1 In Data: %02xh"),
					 InValue);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aISA-P31̎gpJ
	if (Aisa31wClose(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aISA-P31 Closed"));

/*---------------------------------------------------------------------------*/
	// aisa31.dll ̎gpJ
	if (Aisa31wDllClose() == FALSE)
	{
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// aisa31.dll ̃A[hɎs܂B
	}

	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Aisa31wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes)
	{
		case AISA31_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxh"),
							GetLastError());
			break;

		case AISA31_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aISA-P31 error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}

	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
