/*****************************************************************************/
/*	aisa31w.c																 */
/*																			 */
/*	aISA-P31															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1998/03/24															 */
/*																			 */
/*****************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "aisa31w.h"	// aISA-P31


/*---------- X^eBbN֐ -----------------------------------------------*/
static BOOL Aisa31wGetDllExportFunc();


/*---------- X^eBbNϐ(萔) -----------------------------------------*/
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[ϐ
static FARPROC pAisa31GetVersion;
static FARPROC pAisa31Create;
static FARPROC pAisa31Close;
static FARPROC pAisa31GetResource;
static FARPROC pAisa31InPort;
static FARPROC pAisa31OutPort;
static FARPROC pAisa31GetLastError;


/*****************************************************************************/
/* 	  aisa31.dll[h												 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa31wDllOpen()
{
	if (hDLL != NULL)
		return FALSE;

	hDLL = (HMODULE)LoadLibrary(AISA31_DLL_NAME);
	if (hDLL == NULL)
		return FALSE;

	if (Aisa31wGetDllExportFunc() == FALSE)
	{
		Aisa31wDllClose();	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		return FALSE;
	}

	return TRUE;
}

/*****************************************************************************/
/* 	  aisa31.dllA[h											 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa31wDllClose()
{
	if (hDLL == NULL)
		return TRUE;

	if (FreeLibrary(hDLL) == TRUE)
	{
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

/*****************************************************************************/
/* 	  aISA-P31 DLL,Driver̃o[Wԍ擾							 */
/* 	  pdwDllVer DLLo[Wԍi[AhX						 */
/*		  pdwDrvVer Drvo[Wԍi[AhX						 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa31wGetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa31GetVersion)(pdwDllVer, pdwDrvVer);
}

/*****************************************************************************/
/* 	  aISA-P31̔Cӂ̃foCX̎gp錾								 */
/* 	  pwLogSlot	 gpfoCXi[AhX						 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa31wCreate(PWORD pwLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa31Create)(pwLogSlot);
}

/*****************************************************************************/
/* 	  aISA-P31̔Cӂ̃foCX̎gpJ								 */
/* 	  wLogSlot gpfoCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa31wClose(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa31Close)(wLogSlot);
}

/*****************************************************************************/
/* 	  wfoCX̃\[X擾									 */
/* 	  wLogSlot ׂfoCX											 */
/*		  pResInfo \[Xi[\̂̃AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa31wGetResource(WORD wLogSlot, PAISA31R pResInfo)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa31GetResource)(wLogSlot, pResInfo);
}

/*****************************************************************************/
/* 	  Cӂ̃|[gf[^										 */
/* 	  wLogSlot	͂foCX										 */
/*		  dwPort	͂|[g											 */
/*		  pbInValue ̓f[^i[AhX							 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa31wInPort(WORD wLogSlot, DWORD dwPort, PBYTE pbInValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa31InPort)(wLogSlot, dwPort, pbInValue);
}

/*****************************************************************************/
/* 	  Cӂ̃|[gփf[^o										 */
/* 	  wLogSlot	o͂foCX										 */
/*		  dwPort	o͂|[g											 */
/*		  bOutValue o͂f[^											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa31wOutPort(WORD wLogSlot, DWORD dwPort, BYTE bOutValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa31OutPort)(wLogSlot, dwPort, bOutValue);
}

/*****************************************************************************/
/* 	  aISA-P31̃G[R[h											 */
/* 	  wLogSlot	G[foCX								 */
/* ߂l G[R[h														 */
/*****************************************************************************/
DWORD Aisa31wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL)
		return AISA31_ERR_WRAPDLL;

	return (*pAisa31GetLastError)(wLogSlot);
}

/*---------------------------------------------------------------------------*/
/* 	  DLLGNX|[g֐AhX̎擾									 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*---------------------------------------------------------------------------*/
static BOOL Aisa31wGetDllExportFunc()
{
	// Aisa31GetVersion ̃AhX擾
	pAisa31GetVersion = GetProcAddress(hDLL, _T("Aisa31GetVersion"));
	if (pAisa31GetVersion == NULL)
		return FALSE;

	// Aisa31Create ̃AhX擾
	pAisa31Create = GetProcAddress(hDLL, _T("Aisa31Create"));
	if (pAisa31Create == NULL)
		return FALSE;

	// Aisa31Close ̃AhX擾
	pAisa31Close = GetProcAddress(hDLL, _T("Aisa31Close"));
	if (pAisa31Close == NULL)
		return FALSE;

	// Aisa31GetResource ̃AhX擾
	pAisa31GetResource = GetProcAddress(hDLL, _T("Aisa31GetResource"));
	if (pAisa31GetResource == NULL)
		return FALSE;

	// Aisa31InPort ̃AhX擾
	pAisa31InPort = GetProcAddress(hDLL, _T("Aisa31InPort"));
	if (pAisa31InPort == NULL)
		return FALSE;

	// Aisa31OutPort ̃AhX擾
	pAisa31OutPort = GetProcAddress(hDLL, _T("Aisa31OutPort"));
	if (pAisa31OutPort == NULL)
		return FALSE;

	// Aisa31GetLastError ̃AhX擾
	pAisa31GetLastError = GetProcAddress(hDLL, _T("Aisa31GetLastError"));
	if (pAisa31GetLastError == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
